C
C PANGIMG.FOR - Gateway function for PANGIM.FOR
C
C This subroutine is the main gateway to MATLAB.  When a MEX function
C  is executed MATLAB calls the MEXFUNCTION subroutine in the corresponding
C  MEX file.  
C
C Copyright 1984-2004 The MathWorks, Inc.
C $Revision: 1.9.2.1 $
C
      SUBROUTINE MEXFUNCTION(NLHS, PLHS, NRHS, PRHS)
C-----------------------------------------------------------------------
C     (pointer) Replace integer by integer*8 on 64-bit platforms
C
      INTEGER PLHS(*), PRHS(*)

C-----------------------------------------------------------------------
C

      INTEGER NLHS, NRHS
C
C-----------------------------------------------------------------------
C     (pointer) Replace integer by integer*8 on 64-bit platforms
C
      INTEGER MXCREATEDOUBLEMATRIX, MXGETPR
      integer   mxGetM, mxGetN

C-----------------------------------------------------------------------
C

      INTEGER MXGETM, MXGETN
C
C KEEP THE ABOVE SUBROUTINE, ARGUMENT, AND FUNCTION DECLARATIONS FOR USE
C IN ALL YOUR FORTRAN MEX FILES.
C---------------------------------------------------------------------
C
C-----------------------------------------------------------------------
C     (pointer) Replace integer by integer*8 on 64-bit platforms
C
      INTEGER rhoup,rholp,cmup,cmlp,atrup,atrlp,thickp,lamp,nparp
	integer dampingp,vminp,vmaxp,nsp,anglesp
	integer vmp,spectrap

C-----------------------------------------------------------------------
C
      INTEGER M, N,ns,na,npar(2)
      REAL*8 rrhop,rrholp,rcmup(6,6),rcmlp(6,6),ratrlp(3,3)
	real*8 ratrup(3,3),rthickp,rlamp,rdampingp
	real*8 rvminp,rvmaxp,ranglesp(*)
	real*8 rvmp(*),rspectrap(*,*)
	real*8 rns,rnpar

C
C CHECK FOR PROPER NUMBER OF ARGUMENTS
C
      IF (NRHS .NE. 14) THEN
        CALL MEXERRMSGTXT('PANGIM requires 14 input arguments')
      ENDIF
C

C ASSIGN POINTERS TO THE VARIOUS PARAMETERS
C
      vmp = MXGETPR(PLHS(1))
      velmaxp = MXGETPR(PLHS(2))
C
      rhoup = MXGETPR(PRHS(1))
      rholp = MXGETPR(PRHS(2))
      cmup = MXGETPR(PRHS(3))
      cmlp = MXGETPR(PRHS(4))
      atrup = MXGETPR(PRHS(5))
      atrlp = MXGETPR(PRHS(6))
      thickp = MXGETPR(PRHS(7))
      lamp = MXGETPR(PRHS(8))
      nparp = MXGETPR(PRHS(9))
      dampingp = MXGETPR(PRHS(10))
      vminp = MXGETPR(PRHS(11))
      vmaxp = MXGETPR(PRHS(12))
      nsp = MXGETPR(PRHS(13))
      anglesp = MXGETPR(PRHS(14))

	M=mxGetM(anglesp)
	N=mxGetN(anglesp)
	na=max(M,N))
C

C COPY RIGHT HAND ARGUMENTS TO LOCAL ARRAYS OR VARIABLES
      CALL MXCOPYPTRTOREAL8(rhoup, rrhoup, 1)
      CALL MXCOPYPTRTOREAL8(rholp, rrholp, 1)
      CALL MXCOPYPTRTOREAL8(cmup, rcmup, 36)
      CALL MXCOPYPTRTOREAL8(cmlp, rcmlp, 36)
      CALL MXCOPYPTRTOREAL8(atrup, ratrup, 9)
      CALL MXCOPYPTRTOREAL8(atrlp, ratrlp, 9)
      CALL MXCOPYPTRTOREAL8(thickp, rthickp, 1)
      CALL MXCOPYPTRTOREAL8(lamp, rlamp, 1)
      CALL MXCOPYPTRTOreal8(nparp, rnparp, 2)
      CALL MXCOPYPTRTOREAL8(dampingp, rdamplingp, 1)
      CALL MXCOPYPTRTOREAL8(vminp, rvminp, 1)
      CALL MXCOPYPTRTOREAL8(vmaxp, rvmaxp, 1)
      CALL MXCOPYPTRTOREAL8(nsp, rns, 1)
      CALL MXCOPYPTRTOREAL8(anglesp, ranglesp, na)
	ns=int(rns)
	npar(1)=int(rnpar(1))
	npar(2)=int(rnpar(2))

C CREATE A MATRIX FOR RETURN ARGUMENT
C
      PLHS(1) = MXCREATEDOUBLEMATRIX(1,na,0)
      PLHS(2) = MXCREATEDOUBLEMATRIX(ns,na+3,0)
C
C DO THE ACTUAL COMPUTATIONS IN A SUBROUTINE
C       CREATED ARRAYS.  
C
   	CALL MODECONV(ns,rvminp,rvmaxp,na,ranglesp,
    1    ratrup,ratrlp,rcmup,rcmlp, rrhoup,rrholp,rlamp,
    2    rthickp,rdampingp,rmaxvelp,rspectrap)
C
C COPY OUTPUT WHICH IS STORED IN LOCAL ARRAY TO MATRIX OUTPUT
      CALL MXCOPYREAL8TOPTR(rmaxvelp, maxvelp, na*2)
      CALL MXCOPYREAL8TOPTR(rspectrap, spectrap, ns*(na+2))
C
      RETURN
      END
