#include "fintrf.h"
C
C modeconvG.FOR - Gateway function for modeconv.FOR
C
C This is an example of the FORTRAN code required for interfacing
C a .MEX file to MATLAB.
C
C This subroutine is the main gateway to MATLAB.  When a MEX function
C  is executed MATLAB calls the MEXFUNCTION subroutine in the corresponding
C  MEX file.  
C
C Copyright 1984-2004 The MathWorks, Inc.
C $Revision: 1.9.2.1 $
C
      SUBROUTINE MEXFUNCTION(NLHS, PLHS, NRHS, PRHS)
C-----------------------------------------------------------------------
C     (pointer) Replace integer by integer*8 on 64-bit platforms
C
      INTEGER PLHS(*), PRHS(*)

C-----------------------------------------------------------------------
C

      INTEGER NLHS, NRHS
C
C-----------------------------------------------------------------------
C     (pointer) Replace integer by integer*8 on 64-bit platforms
C
      INTEGER MXCREATEDOUBLEMATRIX, MXGETPR

C-----------------------------------------------------------------------
C

      INTEGER MXGETM, MXGETN
C
C KEEP THE ABOVE SUBROUTINE, ARGUMENT, AND FUNCTION DECLARATIONS FOR USE
C IN ALL YOUR FORTRAN MEX FILES.
C---------------------------------------------------------------------
C
C-----------------------------------------------------------------------
C     (pointer) Replace integer by integer*8 on 64-bit platforms
C
	  INTEGER nap,velinp,anglesp,atrup,atrlp,cmup,cmlp
	  INTEGER rhoup,rholp,lamp,thickp,mflgp,nparp
	  integer veloutp, dvp

C-----------------------------------------------------------------------
C
	  INTEGER M, N,na,ipar(2),mflg
	  REAL*8 rnap,rvelinp(200),ranglesp(200),ratrup(3,3)
	  REAL*8 ratrlp(3,3),rcmup(6,6),rcmlp(6,6),rrhoup
	  REAL*8 rrholp,rlamp,rthickp,rmflgp,rnparp(2)
	  real*8 rveloutp(200)
	  real*8 rdvp

	   common /cipar/ ipar
	   		
      IF (NRHS .NE. 14) THEN
        CALL MEXERRMSGTXT('MODEVEL requires 14 input arguments')
      ENDIF
C

C ASSIGN POINTERS TO THE VARIOUS PARAMETERS

C
	  dvp=MXGETPR(PRHS(1))
	  nap = MXGETPR(PRHS(2))
      velinp = MXGETPR(PRHS(3))      
       anglesp = MXGETPR(PRHS(4))
       atrup = MXGETPR(PRHS(5))
       atrlp = MXGETPR(PRHS(6))
		cmup = MXGETPR(PRHS(7))
       cmlp = MXGETPR(PRHS(8))
 	   rhoup = MXGETPR(PRHS(9))
		rholp = MXGETPR(PRHS(10))
	  lamp = MXGETPR(PRHS(11))
      thickp = MXGETPR(PRHS(12))
	  mflgp = MXGETPR(PRHS(13))
	  nparp=MXGETPR(PRHS(14))

C COPY RIGHT HAND ARGUMENTS TO LOCAL ARRAYS OR VARIABLES
        CALL MXCOPYPTRTOREAL8(dvp, rdvp, 1)
        CALL MXCOPYPTRTOREAL8(rhoup, rrhoup, 1)
        CALL MXCOPYPTRTOREAL8(rholp, rrholp, 1)
        CALL MXCOPYPTRTOREAL8(cmup, rcmup, 36)
        CALL MXCOPYPTRTOREAL8(cmlp, rcmlp, 36)
        CALL MXCOPYPTRTOREAL8(atrup, ratrup, 9)
		CALL MXCOPYPTRTOREAL8(atrlp, ratrlp, 9)
        CALL MXCOPYPTRTOREAL8(thickp, rthickp, 1)
        CALL MXCOPYPTRTOREAL8(lamp, rlamp, 1)
        CALL MXCOPYPTRTOREAL8(nparp, rnparp, 2)
	    CALL MXCOPYPTRTOREAL8(nap, rnap, 1)
	          na=int(rnap)
	    CALL MXCOPYPTRTOREAL8(mflgp,rmflgp,1)
        CALL MXCOPYPTRTOREAL8(anglesp, ranglesp, na)
	    CALL MXCOPYPTRTOREAL8(velinp, rvelinp, na)

	    ipar(1)=int(rnparp(1))
	    ipar(2)=int(rnparp(2))
	    mflg=int(rmflgp)
	   
	IF (na .GT. 200) THEN
        CALL MEXERRMSGTXT('MODEVEL handles fewer than 200 angles')
	ENDIF
	  
C CREATE A MATRIX FOR RETURN ARGUMENT
C
      PLHS(1) = MXCREATEDOUBLEMATRIX(1,na,0)
	  
C CREATE A MATRIX FOR RETURN ARGUMENT
C	  
      veloutp = MXGETPR(PLHS(1))
C
C ASSIGN POINTERS TO THE VARIOUS PARAMETERS
C

		
C DO THE ACTUAL COMPUTATIONS IN A SUBROUTINE
C       CREATED ARRAYS.  
C
   	    CALL MODEVEL(rdvp,na,rvelinp,ranglesp,
     1 ratrup,ratrlp,rcmup,rcmlp, rrhoup,rrholp,rlamp,
     2 rthickp,mflg,rveloutp)

C
C COPY OUTPUT WHICH IS STORED IN LOCAL ARRAY TO MATRIX OUTPUT
	   CALL MXCOPYREAL8TOPTR(rveloutp, veloutp, na)


C
      RETURN
      END
